# wxHeaderColumn Class Reference
[Controls]

`#include <wx/headercol.h>`

Inheritance diagram for wxHeaderColumn:
[legend]

## Detailed Description

Represents a column header in controls displaying tabular data such as wxDataViewCtrl or wxGrid.

Notice that this is an abstract base class which is implemented (usually using the information stored in the associated control) by the different controls using wxHeaderCtrl. As the control only needs to retrieve the information about the column, this class defines only the methods for accessing the various column properties but not for changing them as the setters might not be needed at all, e.g. if the column attributes can only be changed via the methods of the main associated control (this is the case for wxGrid for example). If you do want to allow changing them directly using the column itself, you should inherit from wxSettableHeaderColumn instead of this class.

Finally, if you don't already store the column information at all anywhere, you should use the concrete wxHeaderColumnSimple class and wxHeaderCtrlSimple.

##

Library: wxCore

Category: Controls

## Public Member Functions
virtual wxString | GetTitle () const =0
| Get the text shown in the column header.
virtual wxBitmap | GetBitmap () const =0
| Returns the bitmap in the header of the column, if any.
virtual int | GetWidth () const =0
| Returns the current width of the column.
virtual int | GetMinWidth () const =0
| Return the minimal column width.
virtual wxAlignment | GetAlignment () const =0
| Returns the current column alignment.
virtual int | GetFlags () const =0
| Get the column flags.
bool | HasFlag (int flag) const
| Return true if the specified flag is currently set for this column.
virtual bool | IsResizeable () const
| Return true if the column can be resized by the user.
virtual bool | IsSortable () const
| Returns true if the column can be clicked by user to sort the control contents by the field in this column.
virtual bool | IsReorderable () const
| Returns true if the column can be dragged by user to change its order.
virtual bool | IsHidden () const
| Returns true if the column is currently hidden.
bool | IsShown () const
| Returns true if the column is currently shown.
virtual bool | IsSortKey () const =0
| Returns true if the column is currently used for sorting.
virtual bool | IsSortOrderAscending () const =0
| Returns true, if the sort order is ascending.

List of all members.

## Member Function Documentation

virtual wxAlignment wxHeaderColumn::GetAlignment | ( |  | ) | const`[pure virtual]`

Returns the current column alignment.

Returns:
  One of wxALIGN_CENTRE, wxALIGN_LEFT or wxALIGN_RIGHT.

Implemented in wxHeaderColumnSimple.

virtual wxBitmap wxHeaderColumn::GetBitmap | ( |  | ) | const`[pure virtual]`

Returns the bitmap in the header of the column, if any.

If the column has no associated bitmap, wxNullBitmap should be returned.

Implemented in wxHeaderColumnSimple.

virtual int wxHeaderColumn::GetFlags | ( |  | ) | const`[pure virtual]`

Get the column flags.

This method retrieves all the flags at once, you can also use HasFlag() to test for any individual flag or IsResizeable(), IsSortable(), IsReorderable() and IsHidden() to test for particular flags.

Implemented in wxHeaderColumnSimple.

virtual int wxHeaderColumn::GetMinWidth | ( |  | ) | const`[pure virtual]`

Return the minimal column width.

Returns:
  The minimal width such that the user can't resize the column to lesser size (notice that it is still possible to set the column width to smaller value from the program code). Return 0 from here to allow resizing the column to arbitrarily small size.

Implemented in wxHeaderColumnSimple.

virtual wxString wxHeaderColumn::GetTitle | ( |  | ) | const`[pure virtual]`

Get the text shown in the column header.

Implemented in wxHeaderColumnSimple.

virtual int wxHeaderColumn::GetWidth | ( |  | ) | const`[pure virtual]`

Returns the current width of the column.

Returns:
  Width of the column in pixels, never wxCOL_WIDTH_DEFAULT or wxCOL_WIDTH_AUTOSIZE.

Implemented in wxHeaderColumnSimple.

bool wxHeaderColumn::HasFlag | ( | int | flag | ) | const

Return true if the specified flag is currently set for this column.

virtual bool wxHeaderColumn::IsHidden | ( |  | ) | const`[virtual]`

Returns true if the column is currently hidden.

This corresponds to wxCOL_HIDDEN flag which is off by default.

virtual bool wxHeaderColumn::IsReorderable | ( |  | ) | const`[virtual]`

Returns true if the column can be dragged by user to change its order.

This corresponds to wxCOL_REORDERABLE flag which is on by default.

virtual bool wxHeaderColumn::IsResizeable | ( |  | ) | const`[virtual]`

Return true if the column can be resized by the user.

Equivalent to HasFlag(wxCOL_RESIZABLE).

bool wxHeaderColumn::IsShown | ( |  | ) | const

Returns true if the column is currently shown.

This corresponds to the absence of wxCOL_HIDDEN flag.

virtual bool wxHeaderColumn::IsSortable | ( |  | ) | const`[virtual]`

Returns true if the column can be clicked by user to sort the control contents by the field in this column.

This corresponds to wxCOL_SORTABLE flag which is off by default.

virtual bool wxHeaderColumn::IsSortKey | ( |  | ) | const`[pure virtual]`

Returns true if the column is currently used for sorting.

Implemented in wxHeaderColumnSimple.

virtual bool wxHeaderColumn::IsSortOrderAscending | ( |  | ) | const`[pure virtual]`

Returns true, if the sort order is ascending.

Notice that it only makes sense to call this function if the column is used for sorting at all, i.e. if IsSortKey() returns true.

Implemented in wxHeaderColumnSimple.

|  | [ top ]